#!/usr/bin/python
# -*- coding: iso-8859-15 -*-

import os
from optparse import OptionParser
import random
import sys
import time

def twister(options):
    interval = -1
    if options.interval != None:
        try:
            interval = int(options.interval)
        except ValueError:
            interval = -1
        if interval < 0:
            sys.stderr.write('Invalid time interval: %s\n' %(options.interval))
            sys.exit(1)

    varit = [('punaiselle', 'punaiselle.raw'),
             ('vihrelle', 'vihrealle.raw'),
             ('siniselle', 'siniselle.raw'),
             ('keltaiselle', 'keltaiselle.raw')]

    raajat = [('vasen jalka', 'vasen_jalka.raw'),
              ('oikea jalka', 'oikea_jalka.raw'),
              ('vasen ksi', 'vasen_kasi.raw'),
              ('oikea ksi', 'oikea_kasi.raw')]

    if interval < 0:
        print "Paina rivinvaihtoa saadaksesi uuden komennon."
    else:
        print "Paina rivinvaihtoa aloittaaksesi. Uusi komento tulee kerran %d sekunnissa." %(interval)

    while True:
        if interval < 0:
            line = sys.stdin.readline()
            if len(line) == 0:
                break

        raaja = random.choice(raajat)
        raajanimi = raaja[0]
        raajasample = raaja[1]

        vari = random.choice(varit)
        varinimi = vari[0]
        varisample = vari[1]

        print raajanimi, varinimi

        if not options.quiet:
            freq = 44100
            if not options.normal:
                freq += random.randrange(-2000, 1001)

            ret = os.system('aplay -c 1 -r %d -f S16_LE -q -- %s %s' %(freq, raajasample, varisample))
            if ret != 0:
                break

        if interval >= 0:
            time.sleep(interval)

if __name__ == '__main__':

    parser = OptionParser()

    parser.add_option('-i', '--interval',
                      dest = 'interval',
                      default = None,
                      metavar = 't',
                      help = 'Issue new command every t seconds')
    parser.add_option('-n', '--normal',
                      dest = 'normal',
                      default = False,
                      action = 'store_true',
                      help = 'Constant sound frequency (no pitch alternation)')
    parser.add_option('-q', '--quiet',
                      dest = 'quiet',
                      default = False,
                      action = 'store_true',
                      help = 'Be quiet')

    (options, args) = parser.parse_args()

    twister(options)
